function make_graphs
/* Graphical objects */
create xform /graph1 [10,20,600,400]

create xgraph /graph1/voltage -title "Voltage" -hgeom 50% -wgeom 50%
setfield ^ XUnits Sec YUnits V xmax 150 ymin -0.120 ymax -0.050
create xgraph /graph1/conclow -title "Concentration" -hgeom 50% -wgeom 50%
setfield ^ XUnits Sec YUnits mM xmax  150 ymin 0 ymax 10
create xgraph /graph1/conchi -title "Concentration" -xgeom 300 -ygeom 0 -hgeom 50% -wgeom 50%
setfield ^ XUnits Sec YUnits mM xmax 150 ymax 120 ymin 20 
create xgraph /graph1/current -title "current" -xgeom 300 -hgeom 50% -wgeom 50%
setfield ^ XUnits Sec YUnits A xmax 150 ymin -5e-9 ymax 5e-9
xshow /graph1

addmsg clin /graph1/conclow PLOT Conc  *CLin *white
addmsg clout /graph1/conchi PLOT Conc *CLout *white
addmsg kin /graph1/conchi PLOT Conc  *Kin *black
addmsg kout /graph1/conclow PLOT Conc  *Kout *black
addmsg clrev /graph1/voltage PLOT E  *Ecl *white
addmsg krev /graph1/voltage PLOT E *Ek *black
addmsg vm /graph1/voltage PLOT Vm  *Vm *red
addmsg clchan /graph1/current PLOT Ik *Icl *white
addmsg kchan /graph1/current PLOT Ik *Ik *black
reset

end

function change_cl

step  20 -time 
setfield clout Conc 30
step  60 -time 

setfield clout Conc 120
step 60 -time 
end

function change_k
step 20 -time 
setfield kout Conc 10
step 60 -time 

setfield kout Conc 2.5
step 60 -time 
end

function set_cl(dialog)
    str dialog

    float newcl
    newcl = {getfield {dialog} value}

step  20 -time 
setfield clout Conc {newcl}
step  60 -time 


setfield clout Conc 120
step  60 -time 
end

function set_k(dialog)
    str dialog
    float newk

    newk = {getfield {dialog} value}

step 2000 
setfield kout Conc {newk}
step  60 -time 

setfield kout Conc 2.5
step  60 -time 
end


function make_control
    create xform /control [610,20,250,170]
    create xlabel /control/label -hgeom 50 -bg cyan -label "CONTROL PANEL"
    create xbutton /control/RESET -wgeom 50%       -script reset
    create xbutton /control/QUIT -xgeom 0:RESET -ygeom 0:label -wgeom 50% \
        -script quit
    create xbutton /control/Chloride   -ygeom 0:RESET -wgeom 50% \
        -script change_cl
    create xbutton /control/potassium  -xgeom 0:Chloride -ygeom 0:RESET -wgeom 50% \ 
       -script change_k
    create xdialog /control/Clout -label "External chloride" \
                -value 120.0 -script "set_cl <widget>"
    create xdialog /control/Kout -label "External potassium" \
                -value 1 -script "set_k <widget>"

    xshow /control
end
